Browse Source

Install php interface vpnadmin

Julien VAUBOURG 10 years ago
parent
commit
8c49af4731
6 changed files with 320 additions and 5 deletions
  1. 0 0
      conf/init_ynh-vpnclient
  2. 18 0
      conf/nginx_vpnadmin.conf
  3. 0 0
      conf/openvpn_client.conf.tpl
  4. 242 0
      conf/phpfpm_vpnadmin.conf
  5. 15 0
      manifest.json
  6. 45 5
      scripts/install

conf/ynh-vpnclient → conf/init_ynh-vpnclient


+ 18 - 0
conf/nginx_vpnadmin.conf

@@ -0,0 +1,18 @@
+location <TPL:NGINX_LOCATION> {
+       alias <TPL:NGINX_ALIAS>;
+       if ($scheme = http) {
+           rewrite ^ https://$server_name$request_uri? permanent;
+       }
+       client_max_body_size 10G;
+       index index.php;
+       try_files $uri $uri/ index.php;
+       location ~ [^/]\.php(/|$) {
+           fastcgi_split_path_info ^(.+?\.php)(/.*)$;
+           fastcgi_pass unix:/var/run/php5-fpm-roundcube.sock;
+           fastcgi_index index.php;
+           include fastcgi_params;
+           fastcgi_param   REMOTE_USER   $remote_user;
+           fastcgi_param  PATH_INFO $fastcgi_path_info;
+       }
+       include conf.d/yunohost_panel.conf.inc;
+}

conf/client.conf.tpl → conf/openvpn_client.conf.tpl


+ 242 - 0
conf/phpfpm_vpnadmin.conf

@@ -0,0 +1,242 @@
+; Start a new pool named 'www'.
+; the variable $pool can we used in any directive and will be replaced by the
+; pool name ('www' here)
+[<TPL:PHP_NAME>]
+
+; Per pool prefix
+; It only applies on the following directives:
+; - 'slowlog'
+; - 'listen' (unixsocket)
+; - 'chroot'
+; - 'chdir'
+; - 'php_values'
+; - 'php_admin_values'
+; When not set, the global prefix (or /usr) applies instead.
+; Note: This directive can also be relative to the global prefix.
+; Default Value: none
+;prefix = /path/to/pools/$pool
+
+; The address on which to accept FastCGI requests.
+; Valid syntaxes are:
+;   'ip.add.re.ss:port'    - to listen on a TCP socket to a specific address on
+;                            a specific port;
+;   'port'                 - to listen on a TCP socket to all addresses on a
+;                            specific port;
+;   '/path/to/unix/socket' - to listen on a unix socket.
+; Note: This value is mandatory.
+listen = /var/run/php5-fpm-NAMETOCHANGE.sock
+
+; Set listen(2) backlog. A value of '-1' means unlimited.
+; Default Value: 128 (-1 on FreeBSD and OpenBSD)
+;listen.backlog = -1
+
+; List of ipv4 addresses of FastCGI clients which are allowed to connect.
+; Equivalent to the FCGI_WEB_SERVER_ADDRS environment variable in the original
+; PHP FCGI (5.2.2+). Makes sense only with a tcp listening socket. Each address
+; must be separated by a comma. If this value is left blank, connections will be
+; accepted from any ip address.
+; Default Value: any
+;listen.allowed_clients = 127.0.0.1
+
+; Set permissions for unix socket, if one is used. In Linux, read/write
+; permissions must be set in order to allow connections from a web server. Many
+; BSD-derived systems allow connections regardless of permissions.
+; Default Values: user and group are set as the running user
+;                 mode is set to 0666
+listen.owner = www-data
+listen.group = www-data
+listen.mode = 0600
+
+; Unix user/group of processes
+; Note: The user is mandatory. If the group is not set, the default user's group
+;       will be used.
+user = <TPL:PHP_USER>
+group = <TPL:PHP_GROUP>
+
+; Choose how the process manager will control the number of child processes.
+; Possible Values:
+;   static  - a fixed number (pm.max_children) of child processes;
+;   dynamic - the number of child processes are set dynamically based on the
+;             following directives:
+;             pm.max_children      - the maximum number of children that can
+;                                    be alive at the same time.
+;             pm.start_servers     - the number of children created on startup.
+;             pm.min_spare_servers - the minimum number of children in 'idle'
+;                                    state (waiting to process). If the number
+;                                    of 'idle' processes is less than this
+;                                    number then some children will be created.
+;             pm.max_spare_servers - the maximum number of children in 'idle'
+;                                    state (waiting to process). If the number
+;                                    of 'idle' processes is greater than this
+;                                    number then some children will be killed.
+; Note: This value is mandatory.
+pm = dynamic
+
+; The number of child processes to be created when pm is set to 'static' and the
+; maximum number of child processes to be created when pm is set to 'dynamic'.
+; This value sets the limit on the number of simultaneous requests that will be
+; served. Equivalent to the ApacheMaxClients directive with mpm_prefork.
+; Equivalent to the PHP_FCGI_CHILDREN environment variable in the original PHP
+; CGI.
+; Note: Used when pm is set to either 'static' or 'dynamic'
+; Note: This value is mandatory.
+pm.max_children = 6
+
+; The number of child processes created on startup.
+; Note: Used only when pm is set to 'dynamic'
+; Default Value: min_spare_servers + (max_spare_servers - min_spare_servers) / 2
+pm.start_servers = 3
+
+; The desired minimum number of idle server processes.
+; Note: Used only when pm is set to 'dynamic'
+; Note: Mandatory when pm is set to 'dynamic'
+pm.min_spare_servers = 3
+
+; The desired maximum number of idle server processes.
+; Note: Used only when pm is set to 'dynamic'
+; Note: Mandatory when pm is set to 'dynamic'
+pm.max_spare_servers = 5
+
+; The number of requests each child process should execute before respawning.
+; This can be useful to work around memory leaks in 3rd party libraries. For
+; endless request processing specify '0'. Equivalent to PHP_FCGI_MAX_REQUESTS.
+; Default Value: 0
+pm.max_requests = 500
+
+; The URI to view the FPM status page. If this value is not set, no URI will be
+; recognized as a status page. By default, the status page shows the following
+; information:
+;   accepted conn        - the number of request accepted by the pool;
+;   pool                 - the name of the pool;
+;   process manager      - static or dynamic;
+;   idle processes       - the number of idle processes;
+;   active processes     - the number of active processes;
+;   total processes      - the number of idle + active processes.
+;   max children reached - number of times, the process limit has been reached,
+;                          when pm tries to start more children (works only for
+;                          pm 'dynamic')
+; The values of 'idle processes', 'active processes' and 'total processes' are
+; updated each second. The value of 'accepted conn' is updated in real time.
+; Example output:
+;   accepted conn:        12073
+;   pool:                 www
+;   process manager:      static
+;   idle processes:       35
+;   active processes:     65
+;   total processes:      100
+;   max children reached: 1
+; By default the status page output is formatted as text/plain. Passing either
+; 'html' or 'json' as a query string will return the corresponding output
+; syntax. Example:
+;   http://www.foo.bar/status
+;   http://www.foo.bar/status?json
+;   http://www.foo.bar/status?html
+; Note: The value must start with a leading slash (/). The value can be
+;       anything, but it may not be a good idea to use the .php extension or it
+;       may conflict with a real PHP file.
+; Default Value: not set
+pm.status_path = /fpm-status
+
+; The ping URI to call the monitoring page of FPM. If this value is not set, no
+; URI will be recognized as a ping page. This could be used to test from outside
+; that FPM is alive and responding, or to
+; - create a graph of FPM availability (rrd or such);
+; - remove a server from a group if it is not responding (load balancing);
+; - trigger alerts for the operating team (24/7).
+; Note: The value must start with a leading slash (/). The value can be
+;       anything, but it may not be a good idea to use the .php extension or it
+;       may conflict with a real PHP file.
+; Default Value: not set
+ping.path = /ping
+
+; This directive may be used to customize the response of a ping request. The
+; response is formatted as text/plain with a 200 response code.
+; Default Value: pong
+;ping.response = pong
+
+; The timeout for serving a single request after which the worker process will
+; be killed. This option should be used when the 'max_execution_time' ini option
+; does not stop script execution for some reason. A value of '0' means 'off'.
+; Available units: s(econds)(default), m(inutes), h(ours), or d(ays)
+; Default Value: 0
+request_terminate_timeout = 120s
+
+; The timeout for serving a single request after which a PHP backtrace will be
+; dumped to the 'slowlog' file. A value of '0s' means 'off'.
+; Available units: s(econds)(default), m(inutes), h(ours), or d(ays)
+; Default Value: 0
+request_slowlog_timeout = 5s
+
+; The log file for slow requests
+; Default Value: not set
+; Note: slowlog is mandatory if request_slowlog_timeout is set
+slowlog = /var/log/nginx/NAMETOCHANGE.slow.log
+
+; Set open file descriptor rlimit.
+; Default Value: system defined value
+rlimit_files = 4096
+
+; Set max core size rlimit.
+; Possible Values: 'unlimited' or an integer greater or equal to 0
+; Default Value: system defined value
+rlimit_core = 0
+
+; Chroot to this directory at the start. This value must be defined as an
+; absolute path. When this value is not set, chroot is not used.
+; Note: you can prefix with '$prefix' to chroot to the pool prefix or one
+; of its subdirectories. If the pool prefix is not set, the global prefix
+; will be used instead.
+; Note: chrooting is a great security feature and should be used whenever
+;       possible. However, all PHP paths will be relative to the chroot
+;       (error_log, sessions.save_path, ...).
+; Default Value: not set
+;chroot =
+
+; Chdir to this directory at the start.
+; Note: relative path can be used.
+; Default Value: current directory or / when chroot
+chdir = /var/www/NAMETOCHANGE
+
+; Redirect worker stdout and stderr into main error log. If not set, stdout and
+; stderr will be redirected to /dev/null according to FastCGI specs.
+; Note: on highloaded environement, this can cause some delay in the page
+; process time (several ms).
+; Default Value: no
+catch_workers_output = yes
+
+; Pass environment variables like LD_LIBRARY_PATH. All $VARIABLEs are taken from
+; the current environment.
+; Default Value: clean env
+;env[HOSTNAME] = $HOSTNAME
+;env[PATH] = /usr/local/bin:/usr/bin:/bin
+;env[TMP] = /tmp
+;env[TMPDIR] = /tmp
+;env[TEMP] = /tmp
+
+; Additional php.ini defines, specific to this pool of workers. These settings
+; overwrite the values previously defined in the php.ini. The directives are the
+; same as the PHP SAPI:
+;   php_value/php_flag             - you can set classic ini defines which can
+;                                    be overwritten from PHP call 'ini_set'.
+;   php_admin_value/php_admin_flag - these directives won't be overwritten by
+;                                     PHP call 'ini_set'
+; For php_*flag, valid values are on, off, 1, 0, true, false, yes or no.
+
+; Defining 'extension' will load the corresponding shared extension from
+; extension_dir. Defining 'disable_functions' or 'disable_classes' will not
+; overwrite previously defined php.ini values, but will append the new value
+; instead.
+
+; Note: path INI options can be relative and will be expanded with the prefix
+; (pool, global or /usr)
+
+; Default Value: nothing is defined by default except the values in php.ini and
+;                specified at startup with the -d argument
+;php_admin_value[sendmail_path] = /usr/sbin/sendmail -t -i -f www@my.domain.com
+;php_flag[display_errors] = off
+;php_admin_value[error_log] = /var/log/fpm-php.www.log
+;php_admin_flag[log_errors] = on
+;php_admin_value[memory_limit] = 32M
+
+php_value[upload_max_filesize] = 10G
+php_value[post_max_size] = 10G

+ 15 - 0
manifest.json

@@ -15,6 +15,21 @@
   "arguments": {
     "install" : [
       {
+        "name": "Domain",
+        "ask": {
+            "en": "Choose a domain for your VPN web administration"
+        },
+        "example": "domain.org"
+      },
+      {
+        "name": "URL Path",
+        "ask": {
+            "en": "Choose a path for your VPN web administration"
+        },
+        "example": "/vpnadmin",
+        "example": "/vpnadmin"
+      },
+      {
         "name": "Server name",
         "ask": {
             "en": "Select a VPN server"

+ 45 - 5
scripts/install

@@ -1,7 +1,9 @@
 #!/bin/bash
 
 # Retrieve arguments
-server_name=$1
+domain=$1
+url_path=$2
+server_name=$3
 crt_client_path=$2
 crt_client_key_path=$3
 crt_server_ca_path=$4
@@ -10,8 +12,14 @@ ip6_net=$5
 # Check arguments
 # TODO
 
+# Check domain/path availability
+sudo yunohost app checkurl ${domain}${url_path} -a vpnclient
+if [[ ! $? -eq 0 ]]; then
+  exit 1
+fi
+
 # Install packages
-sudo apt-get --assume-yes --force-yes install openvpn
+sudo apt-get --assume-yes --force-yes install openvpn php5-fpm
 
 # Install extra packages
 sudo apt-get --assume-yes --force-yes install sipcalc
@@ -32,7 +40,18 @@ sudo yunohost app setting vpnclient server_name -v ${server_name}
 sudo yunohost app setting vpnclient server_ip6 -v ${server_ip6}
 
 # Copy confs
-sudo install -b -o root -g root -m 0644 ../conf/client.conf.tpl /etc/openvpn/
+sudo install -b -o root -g root -m 0644 ../conf/openvpn_client.conf.tpl /etc/openvpn/client.conf.tpl
+sudo install -b -o root -g root -m 0644 ../conf/nginx_vpnadmin.conf /etc/nginx/conf.d/${domain}.d/vpnadmin.conf
+sudo install -b -o root -g root -m 0644 ../conf/phpfpm_vpnadmin.conf /etc/php5/fpm/pool.d/vpnadmin.conf
+
+# Copy web sources
+sudo mkdir -pm 0755 /var/www/vpnadmin/
+
+sudo cp -a ../conf/sources/* /var/www/vpnadmin/
+
+sudo chown -R root: /var/www/vpnadmin/
+sudo chmod -R 0644 /var/www/vpnadmin/*
+sudo find /var/www/vpnadmin/ -type d -exec chmod +x {} \;
 
 # Copy certificates
 sudo mkdir -pm 0700 /etc/openvpn/keys/
@@ -44,12 +63,24 @@ sudo install -b -o root -g root -m 0600 ${crt_server_ca_path} /etc/openvpn/keys/
 
 sudo rm -f ${crt_client_path} ${crt_client_key_path} ${crt_server_ca_path}
 
+# Create user for the web admin
+sudo useradd -MUr vpnadmin
+
 # Fix confs
 ## openvpn
 sudo sed "s|<TPL:SERVER_NAME>|${server_name}|g" -i /etc/openvpn/client.conf.tpl
 
+## nginx
+sudo sed "s|<TPL:NGINX_LOCATION>|${url_path}|g" -i /etc/nginx/conf.d/${domain}.d/vpnadmin.conf
+sudo sed 's|<TPL:NGINX_ALIAS>|/var/www/vpnadmin/|g' -i /etc/nginx/conf.d/${domain}.d/vpnadmin.conf
+
+# php-fpm
+sudo sed 's|<TPL:PHP_NAME>|vpnadmin|g' -i /etc/php5/fpm/pool.d/vpnadmin.conf
+sudo sed 's|<TPL:PHP_USER>|vpnadmin|g' -i /etc/php5/fpm/pool.d/vpnadmin.conf
+sudo sed 's|<TPL:PHP_GROUP>|vpnadmin|g' -i /etc/php5/fpm/pool.d/vpnadmin.conf
+
 # Copy init script
-sudo install -b -o root -g root -m 0755 ../conf/ynh-vpnclient /etc/init.d/
+sudo install -b -o root -g root -m 0755 ../conf/init_ynh-vpnclient /etc/init.d/ynh-vpnclient
 
 # Fix init script
 ## ynh-vpnclient
@@ -65,11 +96,20 @@ sudo yunohost service add openvpn
 sudo yunohost service stop openvpn
 sudo yunohost service disable openvpn
 
-# Gooo
+sudo yunohost service add php5-fpm
+sudo yunohost service enable php5-fpm
+sudo yunohost service stop php5-fpm
+sudo yunohost service start php5-fpm
+
 sudo yunohost service add ynh-vpnclient
 sudo yunohost service enable ynh-vpnclient
 sudo yunohost service start ynh-vpnclient
 
+sudo service nginx reload
+
+# Update SSO for vpnadmin
+sudo yunohost app ssowatconf
+
 # Restart hotspot service if installed to change NAT configuration (now on tun0)
 sudo yunohost app list -f hotspot --json | grep -q '"installed": true'
 if [ "$?" -eq 0 ]; then